using System;
using System.IO;
using System.Windows.Forms;
using System.Drawing;
using System.Threading;


namespace PluginLib
{	
	/// <summary>
	///  -   OnQuery
	/// </summary>
	public delegate string PluginQueryInvoker ( string xml );

	/// <summary>
	///   ,   
	/// </summary>
	[Serializable]
	public class PluginTestClass
	{
		public event PluginQueryInvoker OnQuery;

		public PluginTestClass()
		{			
			h_PluginQuery = new PluginQueryInvoker ( control_OnQuery );
		}

		public Guid GetId ( )
		{
			return new Guid ( "12341234-abcd-abcd-abcd-abcdabcdabcd" );
		}

		public int GetInterfaceVersion ( int lastknownversion )
		{
			return 081022;
		}

		public string GetModuleVersion ( )
		{
			return "1.0.1";
		}

		public string GetModuleName ( )
		{
			return "test plugin module";
		}

		public string GetDBUpdate ( )
		{
			CMapperXmlItemSetCollection coll = new CMapperXmlItemSetCollection ( "dbupdate" );

			CMapperXmlItemSet iset = new CMapperXmlItemSet ( );
			coll.Add ( iset );
			string text1 = "if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.T_PluginTest' ) )\n";
			text1 += "	Drop Table dbo.T_PluginTest\n";
			text1 += "GO\n";
			string text2 = "Create table dbo.T_PluginTest\n";
			text2 += "(id int identity ( 1, 1 ) Primary Key, name nvarchar ( 50 ), st bit )\nGO\n";
			string text3 = " Insert into T_PluginTest ( Name, St ) Values ( 'Peter', 1 )\nGO";			
			
			iset.Add ( CMapperXmlItem.GetItem ( "sqltext", text1 ) );
			iset.Add ( CMapperXmlItem.GetItem ( "sqltext", text2 ) );
			iset.Add ( CMapperXmlItem.GetItem ( "sqltext", text3 ) );			

			return CMapperXmlItemSetCollection.ToXml ( "dbupdate", coll );
		}

		public string GetForms ( )
		{
			CMapperXmlItemSetCollection coll = new CMapperXmlItemSetCollection ( "forms" );
			CMapperXmlItemSet iset = new CMapperXmlItemSet ( );
			coll.Add ( iset );
			iset.Add ( CMapperXmlItem.GetItem ( "id", "f0100000-0000-0000-0000-000000000000" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "name", "   Form" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "description", "      /  /    " ) );
			iset.Add ( CMapperXmlItem.GetItem ( "controltype", 0, "form" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "module", 0, "dialog" ) );


			iset = new CMapperXmlItemSet ( );
			coll.Add ( iset );
			iset.Add ( CMapperXmlItem.GetItem ( "id", "f0200000-0000-0000-0000-000000000000" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "name", "   Control (1)" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "description", "     " ) );
			iset.Add ( CMapperXmlItem.GetItem ( "controltype", 1, "control" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "module", 0, "dialog" ) );

			iset = new CMapperXmlItemSet ( );
			coll.Add ( iset );
			iset.Add ( CMapperXmlItem.GetItem ( "id", "f0300000-0000-0000-0000-000000000000" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "name", "1" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "description", "  1" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "controltype", 1, "control" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "module", 1, "crm" ) );

			iset = new CMapperXmlItemSet ( );
			coll.Add ( iset );
			iset.Add ( CMapperXmlItem.GetItem ( "id", "f0400000-0000-0000-0000-000000000000" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "name", "2" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "description", "  2" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "controltype", 1, "control" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "module", 1, "crm" ) );

			iset = new CMapperXmlItemSet ( );
			coll.Add ( iset );
			iset.Add ( CMapperXmlItem.GetItem ( "id", "f0500000-0000-0000-0000-000000000000" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "name", "3" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "description", "  3" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "controltype", 0, "form" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "module", 1, "crm" ) );

			iset = new CMapperXmlItemSet ( );
			coll.Add ( iset );
			iset.Add ( CMapperXmlItem.GetItem ( "id", "f0600000-0000-0000-0000-000000000000" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "name", " " ) );
			iset.Add ( CMapperXmlItem.GetItem ( "description", "  ,   " ) );
			iset.Add ( CMapperXmlItem.GetItem ( "controltype", 2, "none" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "module", 2, "scriptcomponent" ) );
			
			return coll.WriteToXml ( "availableforms" );
		}


//
//
//		public double GetParamType ( )
//		{
//			return 0;
//		}
//
//		public string GetInputParams ( string a, string b )
//		{
//			return "";
//		}	
		
		public string GetInputParams ( string xml )
		{
			CMapperXmlItemSetCollection coll = new CMapperXmlItemSetCollection ( "inputparams" );

			#region  
			bool simple = true;
			CMapperXmlItemSetCollection xcoll = CMapperXmlItemSetCollection.FromXml ( xml );
			if ( xcoll == null )
				simple = true;
			else
			{
				Guid idform = Guid.Empty;

				CMapperXmlItemSet iset = xcoll [ 0 ];
				for ( int i = 0; i < iset.Count; i++ )
				{
					CMapperXmlItem item = iset [ i ];
					switch ( item.Key.ToLower() )
					{
						case "idform":
							string val = CMapperXmlItem.GetValueName ( item );
							try
							{
								idform = new Guid ( val );	
							}
							catch{}							
							break;
					}
				}

				if ( idform == Guid.Empty )
					simple = true;
				else if ( idform != new Guid ( "f0600000-0000-0000-0000-000000000000" ) )
					simple = true;
				else
					simple = false;
			}
			#endregion

			if ( simple )
			{
				#region  
				CMapperXmlItemSet iset = new CMapperXmlItemSet ( );

				//1
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "operator" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 1, "string" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", "" ) );			
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "  " ) );

				//2
				iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "clientid" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 2, "int" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", " " ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "  " ) );

				//3
				iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "clientname" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 1, "string" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", " " ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "  " ) );

				//4
				iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "products" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 5, "table" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", "" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "  (Id, Name, Set)" ) );

				//5
				iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "arbitraryarg" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 4, "argument" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", "  " ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "      " ) );

				//6
				iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "users" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 6, "tablequery" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", "" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", " (Id, Name)" ) );
				iset.SubSets.Name = "query";
						
				CMapperXmlItemSet isubset = new CMapperXmlItemSet ( );
				iset.SubSets.Add ( isubset );
				isubset.Name = "query";			
				isubset.Add ( CMapperXmlItem.GetItem ( "connectiontype", "1", "sql" ) );
				isubset.Add ( CMapperXmlItem.GetItem ( "connectionstring", "" ) );
				isubset.Add ( CMapperXmlItem.GetItem ( "sqltext", "Select Id, Name From A_Users" ) );
				/*
				 * Undefined		= 0,
				 * SQLServerSelf	= 1,
				 * SQLServerOther	= 2,
				 * OLE				= 3,
				 * Oracle			= 4,
				 * Odbc				= 5
				 */


				//7
				iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "categories" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 7, "fixedlist" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", "" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "" ) );
			
				iset.SubSets.Name = "categories";
			
				isubset = new CMapperXmlItemSet ( );
				iset.SubSets.Add ( isubset );
				isubset.Name = "category";
				isubset.IdName = "0";			
				isubset.Add ( CMapperXmlItem.GetItem ( "id", "0" ) );
				isubset.Add ( CMapperXmlItem.GetItem ( "name", "" ) );

				isubset = new CMapperXmlItemSet ( );
				iset.SubSets.Add ( isubset );
				isubset.Name = "category";
				isubset.IdName = "1";			
				isubset.Add ( CMapperXmlItem.GetItem ( "id", "1" ) );
				isubset.Add ( CMapperXmlItem.GetItem ( "name", "" ) );
			
				return coll.WriteToXml ( "input" );
				#endregion
			}
			else
			{
				CMapperXmlItemSet iset = new CMapperXmlItemSet ( );

				// 1
				iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "param_number" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 2, "int" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", "" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "         " ) );

				return coll.WriteToXml ( "input" );
			}
		}

		public string GetOutputParams ( string xml )
		{
			CMapperXmlItemSetCollection coll = new CMapperXmlItemSetCollection ( "outputparams" );

			
			#region  
			bool simple = true;
			CMapperXmlItemSetCollection xcoll = CMapperXmlItemSetCollection.FromXml ( xml );
			if ( xcoll == null )
				simple = true;
			else
			{
				Guid idform = Guid.Empty;

				CMapperXmlItemSet iset = xcoll [ 0 ];
				for ( int i = 0; i < iset.Count; i++ )
				{
					CMapperXmlItem item = iset [ i ];
					switch ( item.Key.ToLower() )
					{
						case "idform":
							string val = CMapperXmlItem.GetValueName ( item );
							try
							{
								idform = new Guid ( val );	
							}
							catch{}							
							break;
					}
				}

				if ( idform == Guid.Empty )
					simple = true;
				else if ( idform != new Guid ( "f0600000-0000-0000-0000-000000000000" ) )
					simple = true;
				else
					simple = false;
			}
			#endregion

			if ( simple )
			{
				#region  
				//1
				CMapperXmlItemSet iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "selectedproduct" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 2, "int" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", " " ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", " (id)  " ) );

				//2
				iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "info" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 4, "variable" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", "  " ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "            " ) );

				//3
				iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "dt" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 3, "datetime" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "datetimeformat", "dd.MM.yyyy HH:mm:ss" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", " " ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "  " ) );
			
				return coll.WriteToXml ( "output" );
				#endregion
			}
			else
			{				
				//1
				CMapperXmlItemSet iset = new CMapperXmlItemSet ( );
				coll.Add ( iset );
				iset.Add ( CMapperXmlItem.GetItem ( "paramkey", "powerresult" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramtype", 2, "int" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramname", "" ) );
				iset.Add ( CMapperXmlItem.GetItem ( "paramdescription", "    " ) );

				return coll.WriteToXml ( "output" );
			}
		}



		public string ShowDesign ( string xml )
		{
			MessageBox.Show ( "TEST!!!!" );
				 
			return "";
		}

		private string m_PREPARE = "";
		public string PrepareShow ( string xml )
		{
			#region  
			Guid idform = Guid.Empty;
			double dval = 0;

			bool simple = true;
			CMapperXmlItemSetCollection xcoll = CMapperXmlItemSetCollection.FromXml ( xml );
			
			if ( xcoll == null )
				simple = true;
			else
			{
				for ( int j = 0; j < xcoll.Count; j++ )
				{
					CMapperXmlItemSet iset = xcoll [ j ];
					for ( int i = 0; i < iset.Count; i++ )
					{
						CMapperXmlItem item = iset [ i ];
						switch ( item.Key.ToLower() )
						{
							case "idform":
								string val = CMapperXmlItem.GetValueName ( item );
								try
								{
									idform = new Guid ( val );	
								}
								catch{}
								break;
						}

						if ( idform != Guid.Empty )
							break;
					}
					
					if (( iset.Name != null ) && ( iset.Name.ToLower() == "input" ) && ( iset.SubSets != null ))
					{						
						for ( int k = 0; k < iset.SubSets.Count; k++ )
						{
							CMapperXmlItemSet iset2 = iset.SubSets [ k ];

							if ( iset2.IdName != null )
							{
								if ( iset2.IdName.ToLower() == "param_number" )
								{
									for ( int i = 0; i < iset2.Count; i++ )
									{
										CMapperXmlItem item = iset2 [ i ];
										switch ( item.Key.ToLower() )
										{
											case "paramvalue":
												string val = CMapperXmlItem.GetValueName ( item );
												Double.TryParse ( val, System.Globalization.NumberStyles.Any, null, out dval );
												break;
										}
									}
								}
							}
						}
					}
				}

				if ( idform == Guid.Empty )
					simple = true;
				else if ( idform != new Guid ( "f0600000-0000-0000-0000-000000000000" ) )
					simple = true;
				else
					simple = false;
			}
			#endregion

			if ( simple )
			{
				#region  
				Form1 frm = new Form1 ( );
				frm.SetInput ( m_PREPARE + "\n\n" + xml );
				DialogResult dr = frm.ShowDialog ( );

				CMapperXmlItemSetCollection coll = new CMapperXmlItemSetCollection ( );

				CMapperXmlItemSet commonset = new CMapperXmlItemSet ( );
				commonset.Name = "common";
				coll.Add ( commonset );

				commonset.Add ( CMapperXmlItem.GetItem ( "comment", "   " ) );
				commonset.Add ( CMapperXmlItem.GetItem ( "result", ( dr == DialogResult.OK ) ? "next" : "abort" ) );

				CMapperXmlItemSet allparamset = new CMapperXmlItemSet ( );
				allparamset.Name = "output";
				coll.Add ( allparamset );

				#region  

				//1
				CMapperXmlItemSet paramset = new CMapperXmlItemSet ( );
				allparamset.SubSets.Add ( paramset );
				paramset.Name = "parameter";
				paramset.IdName = "selectedproduct";

				paramset.Add ( CMapperXmlItem.GetItem ( "paramkey", "selectedproduct" ) );
				paramset.Add ( CMapperXmlItem.GetItem ( "paramtype", 2, "int" ) );
				paramset.Add ( CMapperXmlItem.GetItem ( "paramvalue", "12345555" ) );
				
	
				//2
				paramset = new CMapperXmlItemSet ( );
				allparamset.SubSets.Add ( paramset );
				paramset.Name = "parameter";
				paramset.IdName = "info";

				paramset.Add ( CMapperXmlItem.GetItem ( "paramkey", "info" ) );
				paramset.Add ( CMapperXmlItem.GetItem ( "paramtype", 4, "variable" ) );
				paramset.Add ( CMapperXmlItem.GetItem ( "paramvalue", "  !!!" ) );


				//3
				paramset = new CMapperXmlItemSet ( );
				allparamset.SubSets.Add ( paramset );
				paramset.Name = "parameter";
				paramset.IdName = "info";

				paramset.Add ( CMapperXmlItem.GetItem ( "paramkey", "dt" ) );
				paramset.Add ( CMapperXmlItem.GetItem ( "paramtype", 3, "datetime" ) );
				paramset.Add ( CMapperXmlItem.GetItem ( "datetimeformat", "dd.MM.yyyy HH:mm:ss" ) );
				paramset.Add ( CMapperXmlItem.GetItem ( "paramvalue", DateTime.Now.ToString ( "dd.MM.yyyy HH:mm:ss" ) ) );
			
				#endregion

				if ( OnQuery != null )
				{
					CMapperXmlItemSetCollection incoll = new CMapperXmlItemSetCollection ( "query" );
				
					CMapperXmlItemSet inset = new CMapperXmlItemSet ( );
					incoll.Add ( inset );
					inset.Name = "dbquery";
					inset.IdName = "0";
					//inset.Add ( CMapperXmlItem.GetItem ( "type", "db" ) );
					inset.Add ( CMapperXmlItem.GetItem ( "sqltext", "Select Id, Name From A_TaskManager_Tasks" ) );
				
					string ins = CMapperXmlItemSetCollection.ToXml ( "queries", incoll );
					string outs = OnQuery ( ins );
					MessageBox.Show ( outs );
				}
			
				return CMapperXmlItemSetCollection.ToXml ( "result", coll );
				#endregion
			}
			else
			{
				string outs = "";
				if ( OnQuery != null )
				{
					CMapperXmlItemSetCollection incoll = new CMapperXmlItemSetCollection ( "query" );
				
					CMapperXmlItemSet inset = new CMapperXmlItemSet ( );
					incoll.Add ( inset );
					inset.Name = "dbquery";
					inset.IdName = "0";
					//inset.Add ( CMapperXmlItem.GetItem ( "type", "db" ) );
					inset.Add ( CMapperXmlItem.GetItem ( "sqltext", "Select Id, Name From A_TaskManager_Tasks" ) );
				
					string ins = CMapperXmlItemSetCollection.ToXml ( "queries", incoll );
					outs = OnQuery ( ins );					
				}

				FileStream fs = null;
				try
				{
					fs = new FileStream ( "C:\\!!DEL!!\\plugcomment.txt", FileMode.Append, FileAccess.ReadWrite, FileShare.Read );
					if ( fs == null )
						fs = new FileStream ( "C:\\!!DEL!!\\plugcomment.txt", FileMode.Create, FileAccess.ReadWrite, FileShare.Read );

					byte[] bytes = System.Text.Encoding.Unicode.GetBytes ( xml + "\r\n\r\n" + outs + "\r\n\r\n" );
					fs.Write ( bytes, 0, bytes.Length );
					fs.Flush();
				}
				catch
				{
				}
				finally
				{
					if ( fs != null )
						fs.Close();
				}

				Thread.Sleep ( 3000 );                


				CMapperXmlItemSetCollection coll = new CMapperXmlItemSetCollection ( );

				CMapperXmlItemSet allparamset = new CMapperXmlItemSet ( );
				allparamset.Name = "output";
				coll.Add ( allparamset );

				string res = "result!AA " + ((int)Math.Pow ( dval, 2 )).ToString();

				//1
				CMapperXmlItemSet paramset = new CMapperXmlItemSet ( );
				allparamset.SubSets.Add ( paramset );
				paramset.Name = "parameter";
				paramset.IdName = "powerresult";

				paramset.Add ( CMapperXmlItem.GetItem ( "paramkey", "powerresult" ) );
				paramset.Add ( CMapperXmlItem.GetItem ( "paramtype", 2, "int" ) );
				paramset.Add ( CMapperXmlItem.GetItem ( "paramvalue", res.ToString() ) );

				return CMapperXmlItemSetCollection.ToXml ( "result", coll );
			}
		}

		
		public string GetCurrentFillInfo ( string xml )
		{
			CMapperXmlItemSetCollection coll = new CMapperXmlItemSetCollection ( "currentfillinfo" );

			CMapperXmlItemSet iset = new CMapperXmlItemSet ( );
			coll.Add ( iset );
			iset.Name = "asdf";
			iset.IdName = "1234";
			iset.Add ( CMapperXmlItem.GetItem ( "fieldindex", "1" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "fieldvalue", "-" ) );
			
			iset = new CMapperXmlItemSet ( );
			coll.Add ( iset );
			iset.Name = "zxcv";
			iset.IdName = "5678";
			iset.Add ( CMapperXmlItem.GetItem ( "fieldindex", "2" ) );
			iset.Add ( CMapperXmlItem.GetItem ( "fieldvalue", "555" ) );			
			
			return coll.WriteToXml ( "currentfillinfo" );
		}
        
		public string StopShow ( string xml )
		{
			return "";
		}

		private PluginQueryInvoker h_PluginQuery;
		public Control CreateControl ( string xml )
		{
			//  XML  .
			//  ,  
			//    System.Windows.Forms.Control  System.Windows.Forms.Form
			//          GetForms ( );

			if ( xml.ToLower().IndexOf ( "f0500000-0000-0000-0000-000000000000" ) >= 0 )
			{
				TestForm f = new TestForm ( );
				return f;
			}
			else if ( xml.ToLower().IndexOf ( "f0400000-0000-0000-0000-000000000000" ) >= 0 )
			{
				TestControl2 tc2 = new TestControl2 ( );
				return tc2;
			}				
			else
			{
				TestControl tc = new TestControl ( );
				tc.InParam = xml;

				tc.OnQuery += h_PluginQuery;
				return tc;
			}

			return null;
		}

		public string GetControlResult ( string xml )
		{
			CMapperXmlItemSetCollection coll = new CMapperXmlItemSetCollection ( );			

			CMapperXmlItemSet allparamset = new CMapperXmlItemSet ( );
			allparamset.Name = "output";
			coll.Add ( allparamset );

			#region  

			//1
			CMapperXmlItemSet paramset = new CMapperXmlItemSet ( );
			allparamset.SubSets.Add ( paramset );
			paramset.Name = "parameter";
			paramset.IdName = "selectedproduct";

			paramset.Add ( CMapperXmlItem.GetItem ( "paramkey", "selectedproduct" ) );
			paramset.Add ( CMapperXmlItem.GetItem ( "paramtype", 2, "int" ) );
			paramset.Add ( CMapperXmlItem.GetItem ( "paramvalue", "12345555" ) );
				
	
			//2
			paramset = new CMapperXmlItemSet ( );
			allparamset.SubSets.Add ( paramset );
			paramset.Name = "parameter";
			paramset.IdName = "info";

			paramset.Add ( CMapperXmlItem.GetItem ( "paramkey", "info" ) );
			paramset.Add ( CMapperXmlItem.GetItem ( "paramtype", 4, "variable" ) );
			paramset.Add ( CMapperXmlItem.GetItem ( "paramvalue", "  !!!" ) );


			//3
			paramset = new CMapperXmlItemSet ( );
			allparamset.SubSets.Add ( paramset );
			paramset.Name = "parameter";
			paramset.IdName = "info";

			paramset.Add ( CMapperXmlItem.GetItem ( "paramkey", "dt" ) );
			paramset.Add ( CMapperXmlItem.GetItem ( "paramtype", 3, "datetime" ) );
			paramset.Add ( CMapperXmlItem.GetItem ( "datetimeformat", "dd.MM.yyyy HH:mm:ss" ) );
			paramset.Add ( CMapperXmlItem.GetItem ( "paramvalue", DateTime.Now.ToString ( "dd.MM.yyyy HH:mm:ss" ) ) );
			
			#endregion

			return CMapperXmlItemSetCollection.ToXml ( "output", coll );
		}

		public string DoQuery ( string xml )
		{
			MessageBox.Show ( "DoQUERY" + "\n\n" + xml );

			return "asdf";
		}

		private string control_OnQuery ( string xml )
		{
			if ( OnQuery != null )
				return OnQuery ( xml );
			
			return "";
		}
//		private string m_SHOW = "";
//		public string StartShow ( string xml )
//		{
//			m_SHOW = xml;
//			MessageBox.Show ( m_PREPARE + "\n\n---------------------------------------------------\n\n" + m_SHOW );
//			return "started";
//		}
//
//		public string GetResult ( string xml )
//		{
//			return "";
//		}
	}
}
